*** Settings ***

Library    ClassificationLibrary
Library    RPA.Robocorp.WorkItems

*** Variables ***

${model}
${text}
${class}
${threshold}    0.75

*** Tasks ***

Train classification
    Set Task Variables From Work Item

    Should Not Be Empty    ${model}    Model name cannot be emtpy
    Should Not Be Empty    ${text}     Classified text cannot be empty
    Should Not Be Empty    ${class}    Classifier cannot be empty

    Train    ${model}    ${text}    ${class}

Predict classification
    Set Task Variables From Work Item

    Should Not Be Empty     ${model}    Model name cannot be empty
    Should Not Be Empty     ${text}     Classified text cannot be empty

    ${results}=    Predict    ${model}    ${text}
    ${best}=    Set variable    ${results}[0]

    Log  ${results}

    Create Output Work Item
    Set Work Item Variable    class         ${best}[0]
    Set Work Item Variable    confidence    ${best}[1]
    Save Work Item

    IF   ${best}[1] < ${threshold}
        Release Input Work Item    FAILED
        ...  exception_type=BUSINESS
        ...  code=LOW_CONFIDENCE
        ...  message=Confidence ${best}[1] < ${threshold} threshold
    END